--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #FontDialog
  me.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iDialog.ls").new()
	obj._class = #FontDialog
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- currentFont () -> FontID
on currentFont (me)
  obj = $.Qt.Font._make($.Qt._qx.callWidget(me._id,#currentFont))
  me._children.add(obj)
  return obj
end

-- selectedFont () -> FontID
on selectedFont (me)
  obj = $.Qt.Font._make($.Qt._qx.callWidget(me._id,#selectedFont))
  me._children.add(obj)
  return obj
end

-- setCurrentFont (FontID|string)+ (string,int|float,*int,bool)
on setCurrentFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCurrentFont,p1)
end

-- setOption (int,bool)
on setOption (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setOption,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

-- getFont (WidgetID,*FontID,string) -> string
on getFont (scr,p1,p2,p3)
  if ilk(p1)=#instance then p1 = p1._id
  if ilk(p2)=#instance then p2 = p2._id
  return $.Qt._qx.callWidget(#FontDialog,#getFont,p1,p2,p3)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentFontChanged -> string
on currentFontChanged(me,id,p1)
  me._detach(#currentFontChanged,me,p1)
end

-- fontSelected -> string
on fontSelected(me,id,p1)
  me._detach(#fontSelected,me,p1)
end
