--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Ftp
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Ftp
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- bytesAvailable () -> int
on bytesAvailable (me)
  return $.Qt._qx.callObject(me._id,#bytesAvailable)
end

-- cd (string) -> int
on cd (me,p1)
  return $.Qt._qx.callObject(me._id,#cd,p1)
end

-- close () -> int
on close (me)
  return $.Qt._qx.callObject(me._id,#close)
end

-- connectToHost (string,*int) -> int
on connectToHost (me,p1,p2)
	if voidP(p2) then
  	return $.Qt._qx.callObject(me._id,#connectToHost,p1)
  else
  	return $.Qt._qx.callObject(me._id,#connectToHost,p1,p2)
  end if
end

-- currentCommand () -> int
on currentCommand (me)
  return $.Qt._qx.callObject(me._id,#currentCommand)
end

-- get (string) -> int
on get (me,p1)
  return $.Qt._qx.callObject(me._id,#get,p1)
end

-- getError () -> int
on getError (me)
  return $.Qt._qx.callObject(me._id,#getError)
end

-- getErrorString () -> string
on getErrorString (me)
  return $.Qt._qx.callObject(me._id,#getErrorString)
end

-- getFile (string,int) -> int
on getFile (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#getFile,p1,p2)
end

-- list (string) -> int
on list (me,p1)
  return $.Qt._qx.callObject(me._id,#list,p1)
end

-- login (string,string) -> int
on login (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#login,p1,p2)
end

-- mkdir (string) -> int
on mkdir (me,p1)
  return $.Qt._qx.callObject(me._id,#mkdir,p1)
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- put (bytearray,string) -> int
on put_ (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#put,p1,p2)
end

-- putFile (int,string) -> int
on putFile (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
  return $.Qt._qx.callObject(me._id,#putFile,p1,p2)
end

-- rawCommand (string) -> int
on rawCommand (me,p1)
  return $.Qt._qx.callObject(me._id,#rawCommand,p1)
end

-- read (int) -> bytearray|string
on read (me,p1)
  return $.Qt._qx.callObject(me._id,#read,p1)
end

-- readAll () -> bytearray|string
on readAll (me)
  return $.Qt._qx.callObject(me._id,#readAll)
end

-- remove (string) -> int
on remove (me,p1)
  return $.Qt._qx.callObject(me._id,#remove,p1)
end

-- rename (string,string) -> int
on rename (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#rename,p1,p2)
end

-- rmdir (string) -> int
on rmdir (me,p1)
  return $.Qt._qx.callObject(me._id,#rmdir,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setProxy (string,int) -> int
on setProxy (me,p1,p2)
  return $.Qt._qx.callObject(me._id,#setProxy,p1,p2)
end

-- setTransferMode (int) -> int
on setTransferMode (me,p1)
  return $.Qt._qx.callObject(me._id,#setTransferMode,p1)
end

-- state () -> int
on state (me)
  return $.Qt._qx.callObject(me._id,#state)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- commandFinished -> int
on commandFinished(me,id,p1)
  me._detach(#commandFinished,me,p1)
end

-- commandStarted -> int
on commandStarted(me,id,p1)
  me._detach(#commandStarted,me,p1)
end

-- dataTransferProgress -> int,int
on dataTransferProgress(me,id,p1,p2)
  me._detach(#dataTransferProgress,me,p1,p2)
end

-- done -> bool
on done(me,id,p1)
  me._detach(#done,me,p1)
end

-- listInfo -> propList
on listInfo(me,id,p1)
  me._detach(#listInfo,me,p1)
end

-- readyRead
on readyRead(me,id)
  me._detach(#readyRead,me)
end

-- stateChanged -> int
on stateChanged(me,id,p1)
  me._detach(#stateChanged,me,p1)
end
