--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.2
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me,p1)
	me._class = #SystemTrayIcon
	me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
		me._id = $.Qt._qx.newObject(me._class,p1)
	else
		me._id = $.Qt._qx.newObject(me._class)
	end if
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #SystemTrayIcon
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- hide ()
on hide (me)
	$.Qt._qx.callObject(me._id,#hide)
end

-- objectName () -> string
on objectName (me)
	return $.Qt._qx.callObject(me._id,#objectName)
end

-- setContextMenu (MenuID)
on setContextMenu (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callObject(me._id,#setContextMenu,p1)
end

-- setIcon (image|string)
on setIcon (me,p1)
	$.Qt._qx.callObject(me._id,#setIcon,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
	$.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setToolTip (string)
on setToolTip (me,p1)
	$.Qt._qx.callObject(me._id,#setToolTip,p1)
end

-- show ()
on show (me)
	$.Qt._qx.callObject(me._id,#show)
end

-- showMessage (string,string,*int,int)
on showMessage (me,p1,p2,p3,p4)
	if voidP(p3) then p3=1
	if voidP(p4) then p4=10000
	$.Qt._qx.callObject(me._id,#showMessage,p1,p2,p3,p4)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> int
on activated(me,id,p1)
	me._detach(#activated,me,p1)
end

-- messageClicked
on messageClicked(me,id)
	me._detach(#messageClicked,me)
end
