--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #WebSettings
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- localStoragePath () -> string
on localStoragePath (me)
  return $.Qt._qx.callObject(me._id,#localStoragePath)
end

-- setAttribute (int attribute, bool on)
on setAttribute (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setAttribute,p1,p2)
end

-- setLocalStoragePath (string)
on setLocalStoragePath (me, p1)
  $.Qt._qx.callObject(me._id,#setLocalStoragePath,p1)
end

-- testAttribute (int attribute) -> bool
on testAttribute (me,p1)
  return $.Qt._qx.callObject(me._id,#testAttribute,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- clearIconDatabase ()
on clearIconDatabase (scr)
  $.Qt._qx.callObject(#WebSettings,#clearIconDatabase)
end

-- clearMemoryCaches ()
on clearMemoryCaches (scr)
  $.Qt._qx.callObject(#WebSettings,#clearMemoryCaches)
end

-- enablePersistentStorage (string path)
on enablePersistentStorage (scr,p1)
  $.Qt._qx.callObject(#WebSettings,#enablePersistentStorage,p1)
end

-- iconForUrl (string url) -> image
on iconForUrl (scr,p1)
  return $.Qt._qx.callObject(#WebSettings,#iconForUrl,p1)
end

-- setIconDatabasePath (string)
on setIconDatabasePath (scr,p1)
  $.Qt._qx.callObject(#WebSettings,#setIconDatabasePath,p1)
end

-- setOfflineStoragePath (string)
on setOfflineStoragePath (scr,p1)
  $.Qt._qx.callObject(#WebSettings,#setOfflineStoragePath,p1)
end

----------------------------------------
-- SIGNALS
----------------------------------------
