--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Dialog
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #Dialog
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- done (int)
on done (me,p1)
  return $.Qt._qx.callWidget(me._id,#done,p1)
end

-- exec () -> int
on exec (me)
  return $.Qt._qx.callWidget(me._id,#exec)
end

-- open ()
on open (me)
  $.Qt._qx.callWidget(me._id,#open)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- accepted
on accepted(me,id)
  me._detach(#accepted,me)
end

-- finished
on finished(me,id)
  me._detach(#finished,me)
end

-- rejected
on rejected(me,id)
  me._detach(#rejected,me)
end
