--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #GroupBox
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #GroupBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- isChecked () -> bool
on isChecked (me)
  return $.Qt._qx.callWidget(me._id,#isChecked)
end

-- setCheckable (bool)
on setCheckable (me,p1)
  $.Qt._qx.callWidget(me._id,#setCheckable,p1)
end

-- setChecked (bool)
on setChecked (me,p1)
  $.Qt._qx.callWidget(me._id,#setChecked,p1)
end

-- setTitle (string)
on setTitle (me,p1)
  $.Qt._qx.callWidget(me._id,#setTitle,p1)
end

-- title () -> string
on title (me)
  return $.Qt._qx.callWidget(me._id,#title)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- clicked -> bool
on clicked(me,id,p1)
  me._detach(#clicked,me,p1)
end

-- toggled -> bool
on toggled(me,id,p1)
  me._detach(#toggled,me,p1)
end
