--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1)
  me._class = #TableView
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TableView
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- currentPath () -> string path
on currentPath (me)
  return $.Qt._qx.callWidget(me._id,#currentPath)
end

-- pathAt (point) -> string path
on pathAt (me,p1)
  return $.Qt._qx.callWidget(me._id,#pathAt,p1)
end

-- selectedPathes () -> list pathes
on selectedPathes (me)
  return $.Qt._qx.callWidget(me._id,#selectedPathes)
end

-- selectPath (string path)
on selectPath (me,p1)
  $.Qt._qx.callWidget(me._id,#selectPath,p1)
end

-- setAlternatingRowColors (bool)
on setAlternatingRowColors (me,p1)
  $.Qt._qx.callWidget(me._id,#setAlternatingRowColors,p1)
end

--setColumnWidth(int column, int width)
on setColumnWidth (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setColumnWidth,p1,p2)
end

-- setCurrentCell (int,int)
on setCurrentCell (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setCurrentCell,p1,p2)
end

-- setCurrentItem (TableWidgetItem)
on setCurrentItem (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setCurrentItem,p1)
end

-- setDefaultDropAction (int action)
on setDefaultDropAction (me,p1)
  $.Qt._qx.callWidget(me._id,#setDefaultDropAction,p1)
end

-- setDragDropMode (int)
on setDragDropMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setDragDropMode,p1)
end

-- setDragEnabled (bool)
on setDragEnabled (me,p1)
  $.Qt._qx.callWidget(me._id,#setDragEnabled,p1)
end

-- setDropIndicatorShown (bool)
on setDropIndicatorShown (me,p1)
  $.Qt._qx.callWidget(me._id,#setDropIndicatorShown,p1)
end

-- setEditTriggers (int)
on setEditTriggers (me,p1)
  $.Qt._qx.callWidget(me._id,#setEditTriggers,p1)
end

-- setFilter (int filter)
on setFilter (me,p1)
  $.Qt._qx.callWidget(me._id,#setFilter,p1)
end

--setHorizontalDefaultSectionSize (int size)
on setHorizontalDefaultSectionSize (me,p1)
  $.Qt._qx.callWidget(me._id,#setHorizontalDefaultSectionSize,p1)
end

--setHorizontalHeaderDefaultAlignment (int alignment)
on setHorizontalHeaderDefaultAlignment (me,p1)
  $.Qt._qx.callWidget(me._id,#setHorizontalHeaderDefaultAlignment,p1)
end

--setHorizontalStretchLastSection (bool flag)
on setHorizontalStretchLastSection (me,p1)
  $.Qt._qx.callWidget(me._id,#setHorizontalStretchLastSection,p1)
end

-- setRawDropMode (bool)
on setRawDropMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setRawDropMode,p1)
end

--setResizeMode (int mode)
on setResizeMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setResizeMode,p1)
end

-- setRoot (string path,*readOnlyFlag)
on setRoot (me,p1,p2)
	if voidP(p2) then
  	$.Qt._qx.callWidget(me._id,#setRoot,p1)
  else
  	$.Qt._qx.callWidget(me._id,#setRoot,p1,p2)
  end if
end

-- setRootIndex (string path)
on setRootIndex (me,p1)
  $.Qt._qx.callWidget(me._id,#setRootIndex,p1)
end

-- setRowHeight (int row, int height)
on setRowHeight (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setRowHeight,p1,p2)
end

-- setSelectionBehavior (int)
on setSelectionBehavior (me,p1)
  $.Qt._qx.callWidget(me._id,#setSelectionBehavior,p1)
end

-- setShowGrid (bool)
on setShowGrid (me,p1)
  $.Qt._qx.callWidget(me._id,#setShowGrid,p1)
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
  $.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- setSupportedDragActions (int actions)
on setSupportedDragActions (me,p1)
  $.Qt._qx.callWidget(me._id,#setSupportedDragActions,p1)
end

-- setVerticalDefaultSectionSize (int size)
on setVerticalDefaultSectionSize (me,p1)
  $.Qt._qx.callWidget(me._id,#setVerticalDefaultSectionSize,p1)
end

-- setVerticalHeaderVisible (bool flag)
on setVerticalHeaderVisible (me,p1)
  $.Qt._qx.callWidget(me._id,#setVerticalHeaderVisible,p1)
end

-- setVerticalStretchLastSection (bool flag)
on setVerticalStretchLastSection (me,p1)
  $.Qt._qx.callWidget(me._id,#setVerticalStretchLastSection,p1)
end

-- sortByColumn (int column, *int order)
on sortByColumn (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#sortByColumn,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- activated -> string
on activated(me,id,p1)
  me._detach(#activated,me,p1)
end

-- clicked -> string
on clicked(me,id,p1)
  me._detach(#clicked,me,p1)
end

-- doubleClicked -> string
on doubleClicked(me,id,p1)
  me._detach(#doubleClicked,me,p1)
end

-- entered -> string
on entered(me,id,p1)
  me._detach(#entered,me,p1)
end

-- pressed -> string
on pressed(me,id,p1)
  me._detach(#pressed,me,p1)
end
