--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.2
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1,p2)
	me._class = #TableWidget
	me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	if voidP(p2) then
		me._id = $.Qt._qx.newWidget(me._class,p1)
	else
		me._id = $.Qt._qx.newWidget(me._class,p1,p2)
	end if
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TableWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- clear ()
on clear (me)
	return $.Qt._qx.callWidget(me._id,#clear)
end

-- clearContents ()
on clearContents (me)
	return $.Qt._qx.callWidget(me._id,#clearContents)
end

-- columnCount () -> int
on columnCount (me)
	return $.Qt._qx.callWidget(me._id,#columnCount)
end

-- currentItem () -> TableWidgetItem
on currentItem (me)
	id = $.Qt._qx.callWidget(me._id,#currentItem)
	if id then
		obj = $.Qt.TableWidgetItem._make(id)
		me._children.add(obj)
		return obj
	end if
end

-- currentRow () -> int
on currentRow (me)
	return $.Qt._qx.callWidget(me._id,#currentRow)
end

-- horizontalHeaderItem(int column) -> TableWidgetItem
on horizontalHeaderItem (me,p1)
	obj = $.Qt.TableWidgetItem._make($.Qt._qx.callWidget(me._id,#horizontalHeaderItem,p1))
	me._children.add(obj)
	return obj
end

-- horizontalHeaderResizeSections(int mode)
on horizontalHeaderResizeSections (me,p1)
	$.Qt._qx.callWidget(me._id,#horizontalHeaderResizeSections,p1)
end

-- insertRow (int row)
on insertRow (me,p1)
	$.Qt._qx.callWidget(me._id,#insertRow,p1)
end

-- item (int,int) -> TableWidgetItem
on item_ (me,p1,p2)
	obj = $.Qt.TableWidgetItem._make($.Qt._qx.callWidget(me._id,#item,p1,p2))
	me._children.add(obj)
	return obj
end

-- removeCellWidget(int row, int column)
on removeCellWidget (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#removeCellWidget,p1,p2)
end

-- removeColumn (int column) -> bool
on removeColumn (me,p1)
	return $.Qt._qx.callWidget(me._id,#removeColumn,p1)
end

-- removeRow (int row) -> bool
on removeRow (me,p1)
	return $.Qt._qx.callWidget(me._id,#removeRow,p1)
end

-- resizeRowsToContents()
on resizeRowsToContents (me)
	$.Qt._qx.callWidget(me._id,#resizeRowsToContents)
end

-- rowCount () -> int
on rowCount (me)
	return $.Qt._qx.callWidget(me._id,#rowCount)
end

-- scrollToBottom ()
on scrollToBottom (me)
	$.Qt._qx.callWidget(me._id,#scrollToBottom)
end

-- scrollToTop ()
on scrollToTop (me)
	$.Qt._qx.callWidget(me._id,#scrollToTop)
end

-- selectedItems () -> TableWidgetItemIDs
on selectedItems (me)
	--return $.Qt._qx.callWidget(me._id,#selectedItems)
	sel = $.Qt._qx.callWidget(me._id,#selectedItems)
	res = []
	repeat with id in sel
		obj = $.Qt.TableWidgetItem._make(id)
  		me._children.add(obj)
  		res.add(obj)
  	end repeat
  	return res
end

-- selectRow (int row)
on selectRow (me,p1)
	$.Qt._qx.callWidget(me._id,#selectRow,p1)
end

-- setAlternatingRowColors (bool)
on setAlternatingRowColors (me,p1)
	$.Qt._qx.callWidget(me._id,#setAlternatingRowColors,p1)
end

-- setCellWidget(int row, int column, QWidget * widget)
on setCellWidget (me,p1,p2,p3)
	if ilk(p3)=#instance then
		--me._children.add(p3) -- ???
		p3 = p3._id
	end if
	$.Qt._qx.callWidget(me._id,#setCellWidget,p1,p2,p3)
end

-- setColumnCount (int)
on setColumnCount (me,p1)
	$.Qt._qx.callWidget(me._id,#setColumnCount,p1)
end

--setColumnWidth(int column, int width)
on setColumnWidth (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setColumnWidth,p1,p2)
end

-- setCurrentCell (int,int)
on setCurrentCell (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setCurrentCell,p1,p2)
end

-- setCurrentItem (TableWidgetItem)
on setCurrentItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#setCurrentItem,p1)
end

-- setDragEnabled (bool)
on setDragEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragEnabled,p1)
end

-- setDragDropMode (int)
on setDragDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragDropMode,p1)
end

-- setEditTriggers (int)
on setEditTriggers (me,p1)
	$.Qt._qx.callWidget(me._id,#setEditTriggers,p1)
end

--setHorizontalDefaultSectionSize (int size)
on setHorizontalDefaultSectionSize (me,p1)
	$.Qt._qx.callWidget(me._id,#setHorizontalDefaultSectionSize,p1)
end

--setHorizontalHeaderDefaultAlignment (int alignment)
on setHorizontalHeaderDefaultAlignment (me,p1)
	$.Qt._qx.callWidget(me._id,#setHorizontalHeaderDefaultAlignment,p1)
end

-- setHorizontalHeaderLabels (list)
on setHorizontalHeaderLabels (me,p1)
	$.Qt._qx.callWidget(me._id,#setHorizontalHeaderLabels,p1)
end

--setHorizontalStretchLastSection (bool flag)
on setHorizontalStretchLastSection (me,p1)
	$.Qt._qx.callWidget(me._id,#setHorizontalStretchLastSection,p1)
end

-- setItem (int,int,TableWidgetItemID)
on setItem (me,p1,p2,p3)
	if ilk(p3)=#instance then p3 = p3._id
	$.Qt._qx.callWidget(me._id,#setItem,p1,p2,p3)
end

-- setRawDropMode (bool)
on setRawDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setRawDropMode,p1)
end

--setResizeMode (int mode)
on setResizeMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setResizeMode,p1)
end

-- setRowCount (int)
on setRowCount (me,p1)
	$.Qt._qx.callWidget(me._id,#setRowCount,p1)
end

-- setRowHeight (int row, int height)
on setRowHeight (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setRowHeight,p1,p2)
end

-- setSelectionBehavior (int)
on setSelectionBehavior (me,p1)
	$.Qt._qx.callWidget(me._id,#setSelectionBehavior,p1)
end

--setSelectionMode (int mode)
on setSelectionMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setSelectionMode,p1)
end

-- setShowGrid (bool)
on setShowGrid (me,p1)
	$.Qt._qx.callWidget(me._id,#setShowGrid,p1)
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

--setVerticalDefaultSectionSize (int size)
on setVerticalDefaultSectionSize (me,p1)
	$.Qt._qx.callWidget(me._id,#setVerticalDefaultSectionSize,p1)
end

-- setVerticalHeaderLabels (list)
on setVerticalHeaderLabels (me,p1)
	$.Qt._qx.callWidget(me._id,#setVerticalHeaderLabels,p1)
end

--setVerticalHeaderVisible (bool flag)
on setVerticalHeaderVisible (me,p1)
	$.Qt._qx.callWidget(me._id,#setVerticalHeaderVisible,p1)
end

--setVerticalStretchLastSection (bool flag)
on setVerticalStretchLastSection (me,p1)
	$.Qt._qx.callWidget(me._id,#setVerticalStretchLastSection,p1)
end

-- sortByColumn (int column, *int order)
on sortByColumn (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#sortByColumn,p1,p2)
end

-- sortItems (int,int)
on sortItems (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#sortItems,p1,p2)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentItemChanged -> int,int
on currentItemChanged(me,id,p1,p2)
	p1 = $.Qt.TableWidgetItem._make(p1)
	p2 = $.Qt.TableWidgetItem._make(p2)
	me._detach(#currentItemChanged,me,p1,p2)
end

-- cellActivated -> int,int
on cellActivated(me,id,p1,p2)
	me._detach(#cellActivated,me,p1,p2)
end

-- cellChanged -> int,int
on cellChanged(me,id,p1,p2)
	me._detach(#cellChanged,me,p1,p2)
end

-- cellClicked -> int,int
on cellClicked(me,id,p1,p2)
	me._detach(#cellClicked,me,p1,p2)
end

-- cellDoubleClicked -> int,int
on cellDoubleClicked(me,id,p1,p2)
	me._detach(#cellDoubleClicked,me,p1,p2)
end

-- cellEntered -> int,int
on cellEntered(me,id,p1,p2)
	me._detach(#cellEntered,me,p1,p2)
end

-- cellPressed -> int,int
on cellPressed(me,id,p1,p2)
	me._detach(#cellPressed,me,p1,p2)
end
