--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TextBrowser
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TextBrowser
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- backward ()
on backward (me)
  $.Qt._qx.callWidget(me._id,#backward)
end

-- forward ()
on forward (me)
  $.Qt._qx.callWidget(me._id,#forward)
end

-- home ()
on home (me)
  $.Qt._qx.callWidget(me._id,#home)
end

-- reload ()
on reload (me)
  $.Qt._qx.callWidget(me._id,#reload)
end

-- setHtml (string)
on setHtml (me,p1)
  $.Qt._qx.callWidget(me._id,#setHtml,p1)
end

-- setOpenExternalLinks (bool)
on setOpenExternalLinks (me,p1)
  $.Qt._qx.callWidget(me._id,#setOpenExternalLinks,p1)
end

-- setOpenLinks (bool)
on setOpenLinks (me,p1)
  $.Qt._qx.callWidget(me._id,#setOpenLinks,p1)
end

-- setSource (string)
on setSource (me,p1)
  $.Qt._qx.callWidget(me._id,#setSource,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- source () -> string
on source (me)
  return $.Qt._qx.callWidget(me._id,#source)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- anchorClicked -> string
on anchorClicked(me,id,p1)
  me._detach(#anchorClicked,me,p1)
end

-- backwardAvailable -> bool
on backwardAvailable(me,id,p1)
  me._detach(#backwardAvailable,me,p1)
end

-- forwardAvailable -> bool
on forwardAvailable(me,id,p1)
  me._detach(#forwardAvailable,me,p1)
end

-- highlighted -> string
on highlighted(me,id,p1)
  me._detach(#highlighted,me,p1)
end

-- historyChanged
on historyChanged(me,id)
  me._detach(#historyChanged,me)
end

-- sourceChanged -> string
on sourceChanged(me,id,p1)
  me._detach(#sourceChanged,me,p1)
end
