--!parent
--!encoding=utf-8

--****************************************************************************
-- @package	 Qt OOP API
-- @version		0.3
-- @requires	Xtra("QtWidgets")
-- @author	 	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me,p1,p2)
	me._class = #TreeWidget
	me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	if ilk(p1)=#instance then
		p1._children.add(me)
		p1 = p1._id
	end if
	if voidP(p2) then
		me._id = $.Qt._qx.newWidget(me._class,p1)
	else
		me._id = $.Qt._qx.newWidget(me._class,p1,p2)
	end if
	return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TreeWidget
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addTopLevelItem (TreeWidgetItemID)
on addTopLevelItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#addTopLevelItem,p1)
end

-- columnCount () -> int
on columnCount (me)
	return $.Qt._qx.callWidget(me._id,#columnCount)
end

-- currentColumn () -> int
on currentColumn (me)
	return $.Qt._qx.callWidget(me._id,#currentColumn)
end

-- currentItem () -> TreeWidgetItemID
on currentItem (me)
	id = $.Qt._qx.callWidget(me._id,#currentItem)
	if id=0 then return 0
	obj = $.Qt.TreeWidgetItem._make(id)
	me._children.add(obj)
	return obj
end

-- editItem (TreeWidgetItemID,*int)
on editItem (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#editItem,p1,p2)
end

-- findItems (string,int,*int) -> TreeWidgetItemIDs
on findItems (me,p1,p2,p3)
	return $.Qt._qx.callWidget(me._id,#findItems,p1,p2,p3)
end

-- insertTopLevelItem (int,TreeWidgetItemID)
on insertTopLevelItem (me,p1,p2)
	if ilk(p2)=#instance then p2 = p2._id
	$.Qt._qx.callWidget(me._id,#insertTopLevelItem,p1,p2)
end

-- invisibleRootItem () -> TreeWidgetItemID
on invisibleRootItem (me)
	obj = $.Qt.TreeWidgetItem._make($.Qt._qx.callWidget(me._id,#invisibleRootItem))
	me._children.add(obj)
	return obj
end

-- isSortingEnabled () -> bool
on isSortingEnabled (me)
	return $.Qt._qx.callWidget(me._id,#isSortingEnabled)
end

-- itemAt (int,int) -> TreeWidgetItemID
on itemAt (me,p1,p2)
	obj = $.Qt.TreeWidgetItem._make($.Qt._qx.callWidget(me._id,#itemAt,p1,p2))
	me._children.add(obj)
	return obj
end

-- resizeColumnToContents (int)
on resizeColumnToContents (me,p1)
	$.Qt._qx.callWidget(me._id,#resizeColumnToContents,p1)
end

-- selectedItems () -> TreeWidgetItemIDs
on selectedItems (me)
	return $.Qt._qx.callWidget(me._id,#selectedItems)
end

-- setColumnCount (int)
on setColumnCount (me,p1)
	$.Qt._qx.callWidget(me._id,#setColumnCount,p1)
end

--setColumnWidth(int column, int width)
on setColumnWidth (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setColumnWidth,p1,p2)
end

-- setCurrentItem (TreeWidgetItemID)
on setCurrentItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#setCurrentItem,p1)
end

-- setDragDropMode (int)
on setDragDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragDropMode,p1)
end

-- setDragEnabled (bool)
on setDragEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setDragEnabled,p1)
end

-- setHeaderHidden (bool)
on setHeaderHidden (me,p1)
	$.Qt._qx.callWidget(me._id,#setHeaderHidden,p1)
end

-- setHeaderItem (TreeWidgetItemID)
on setHeaderItem (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#setHeaderItem,p1)
end

-- setHeaderLabel (string)
on setHeaderLabel (me,p1)
	$.Qt._qx.callWidget(me._id,#setHeaderLabel,p1)
end

-- setHeaderLabels (list)
on setHeaderLabels (me,p1)
	$.Qt._qx.callWidget(me._id,#setHeaderLabels,p1)
end

-- setIconSize (int,int)
on setIconSize (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setIconSize,p1,p2)
end

-- setItemWidget (ListWidgetItem, int column, Widget)
on setItemWidget (me,p1,p2,p3)
	if ilk(p1)=#instance then p1 = p1._id
	if ilk(p3)=#instance then p3 = p3._id
	$.Qt._qx.callWidget(me._id,#setItemWidget,p1,p2,p3)
end

-- setRawDropMode (bool)
on setRawDropMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setRawDropMode,p1)
end

--setSelectionMode (int mode)
on setSelectionMode (me,p1)
	$.Qt._qx.callWidget(me._id,#setSelectionMode,p1)
end

--setShowGrid (*color lineColor)
on setShowGrid (me,p1)
	if voidP(p1) then
		$.Qt._qx.callWidget(me._id,#setShowGrid)
	else
		$.Qt._qx.callWidget(me._id,#setShowGrid,p1)
	end if
end

-- setSortingEnabled (bool)
on setSortingEnabled (me,p1)
	$.Qt._qx.callWidget(me._id,#setSortingEnabled,p1)
end

-- sortByColumn (int,*int)
on sortByColumn (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#sortByColumn,p1,p2)
end

-- sortColumn () -> int
on sortColumn (me)
	return $.Qt._qx.callWidget(me._id,#sortColumn)
end

-- sortItems (int,int)
on sortItems (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#sortItems,p1,p2)
end

-- topLevelItem (int) -> TreeWidgetItemID
on topLevelItem (me,p1)
	obj = $.Qt.TreeWidgetItem._make($.Qt._qx.callWidget(me._id,#topLevelItem,p1))
	me._children.add(obj)
	return obj
end

-- topLevelItemCount () -> int
on topLevelItemCount (me)
	return $.Qt._qx.callWidget(me._id,#topLevelItemCount)
end

-- visualItemRect (int) -> rect
on visualItemRect (me,p1)
	return $.Qt._qx.callWidget(me._id,#visualItemRect,p1)
end

-- closePersistentEditor (int,*int)
on closePersistentEditor (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
	if voidP(p2) then
		$.Qt._qx.callWidget(me._id,#closePersistentEditor,p1)
	else
		$.Qt._qx.callWidget(me._id,#closePersistentEditor,p1,p2)
	end if
end

-- openPersistentEditor (int,*int)
on openPersistentEditor (me,p1,p2)
	if ilk(p1)=#instance then p1 = p1._id
	if voidP(p2) then
		$.Qt._qx.callWidget(me._id,#openPersistentEditor,p1)
	else
		$.Qt._qx.callWidget(me._id,#openPersistentEditor,p1,p2)
	end if
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- currentItemChanged -> int,int
on currentItemChanged(me,id,p1,p2)
	p1 = $.Qt.TreeWidgetItem._make(p1)
	p2 = $.Qt.TreeWidgetItem._make(p2)
	me._detach(#currentItemChanged,me,p1,p2)
end

-- iconSize () -> list widthAndHeight
on iconSize (me)
	return $.Qt._qx.callWidget(me._id,#iconSize)
end

-- itemActivated -> int,int
on itemActivated(me,id,p1,p2)
	me._detach(#itemActivated,me,p1,p2)
end

-- itemChanged -> int,int
--on itemChanged(me,id,p1,p2)
--	me._detach(#itemChanged,me,p1,p2)
--end

-- itemChanged -> int item, int column
on itemChanged(me,id,p1,p2)
	obj = $.Qt.TreeWidgetItem._make(p1)
	--me._children.add(obj) -- ???
	me._detach(#itemChanged,me,obj,p2)
end

-- itemClicked -> int,int
on itemClicked(me,id,p1,p2)
	obj = $.Qt.TreeWidgetItem._make(p1)
	me._detach(#itemClicked,me,obj,p2)
end

-- itemCollapsed -> int
on itemCollapsed(me,id,p1)
	me._detach(#itemCollapsed,me,p1)
end

-- itemDoubleClicked -> int,int
on itemDoubleClicked(me,id,p1,p2)
	me._detach(#itemDoubleClicked,me,p1,p2)
end

-- itemEntered -> int,int
on itemEntered(me,id,p1,p2)
	me._detach(#itemEntered,me,p1,p2)
end

-- itemExpanded -> int
--on itemExpanded(me,id,p1)
--	me._detach(#itemExpanded,me,p1)
--end

-- NEW
on itemExpanded(me,id,p1)
	obj = $.Qt.TreeWidgetItem._make(p1)
	--me._children.add(obj) -- ???
	me._detach(#itemExpanded,me,obj)
end

-- itemPressed -> int,int
on itemPressed(me,id,p1,p2)
	me._detach(#itemPressed,me,p1,p2)
end

-- itemSelectionChanged
on itemSelectionChanged(me,id)
	me._detach(#itemSelectionChanged,me)
end
