--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: SHELL
-- @author		Valentin Schmidt
-- @version	 0.5
-- @requires	xtra("Shell")
--****************************************************************************

property $
property ancestor

-- win only
property cb_stdout
property cb_stderr
property cb_complete
property cb_target

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	$.loadXtras(me.libdir, ["Shell.x32"], ["ShellXtra.xtra"])
	--put Xtra("Shell").interface()
	
	me.ancestor = xtra("Shell").new() -- instance version!

	-- libs
	if $.OS="win" then
		me.$.import("detacher")
	end if
	
	return me
end

----------------------------------------
-- win only
----------------------------------------
on shell_cmd_thread (me, command, props)
	if ilk(props)=#propList then
	
		if symbolP(props["cb_stdout"]) then
			me.cb_stdout = props["cb_stdout"]
			props["cb_stdout"] = #slotStdout
		end if
		
		if symbolP(props["cb_stderr"]) then
			me.cb_stderr = props["cb_stderr"]
			props["cb_stderr"] = #slotStderr
		end if
		
		if symbolP(props["cb_complete"]) then
			me.cb_complete = props["cb_complete"]
			props["cb_complete"] = #slotComplete
		end if
		
		me.cb_target = props["cb_target"]
		if voidP(me.cb_target) then me.cb_target = _movie
		props["cb_target"] = me
	
	end if
	return me.ancestor.shell_cmd_thread(command, props)
end

----------------------------------------
-- @callback
----------------------------------------
on slotStdout (me, str)
	me.$.detacher.detach(me.cb_stdout, me.cb_target, str)
end

----------------------------------------
-- @callback
----------------------------------------
on slotStderr (me, str)
	me.$.detacher.detach(me.cb_stderr, me.cb_target, str)
end

----------------------------------------
-- @callback
----------------------------------------
on slotComplete (me, exitCode)
	me.$.detacher.detach(me.cb_complete, me.cb_target, exitCode)
end
